summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDavid Kalnischkies <kalnischkies@gmail.com>2010-10-21 16:54:28 +0200
committerDavid Kalnischkies <kalnischkies@gmail.com>2010-10-21 16:54:28 +0200
commit4260fd3972cc0c01e6cbc825063c06311d440f9b (patch)
tree2feb39cfd211f8afaf3f8b329d932e972802a07b
parent95fe33dc131bee1a0917ba647e44855c10083ab5 (diff)
* apt-pkg/contrib/fileutl.cc:
- Add a FileFd::FileSize() method to get the size of the underlying file and not the size of the content in the file as FileFd::Size() does - the sizes can differ since the direct gzip integration * methods/{gzip,bzip2}.cc: - use FileSize() to determine if the file is invalid (Closes: #600852)
-rw-r--r--apt-pkg/contrib/fileutl.cc18
-rw-r--r--apt-pkg/contrib/fileutl.h1
-rw-r--r--debian/changelog12
-rw-r--r--methods/bzip2.cc2
-rw-r--r--methods/gzip.cc2
-rwxr-xr-xtest/integration/test-bug-595691-empty-and-broken-archive-files159
6 files changed, 135 insertions, 59 deletions
diff --git a/apt-pkg/contrib/fileutl.cc b/apt-pkg/contrib/fileutl.cc
index cbf1d64a9..f4ab066d7 100644
--- a/apt-pkg/contrib/fileutl.cc
+++ b/apt-pkg/contrib/fileutl.cc
@@ -910,18 +910,24 @@ unsigned long FileFd::Tell()
return Res;
}
/*}}}*/
-// FileFd::Size - Return the size of the file /*{{{*/
+// FileFd::FileSize - Return the size of the file /*{{{*/
// ---------------------------------------------------------------------
/* */
-unsigned long FileFd::Size()
+unsigned long FileFd::FileSize()
{
struct stat Buf;
- unsigned long size;
- off_t orig_pos;
if (fstat(iFd,&Buf) != 0)
return _error->Errno("fstat","Unable to determine the file size");
- size = Buf.st_size;
+ return Buf.st_size;
+}
+ /*}}}*/
+// FileFd::Size - Return the size of the content in the file /*{{{*/
+// ---------------------------------------------------------------------
+/* */
+unsigned long FileFd::Size()
+{
+ unsigned long size = FileSize();
// only check gzsize if we are actually a gzip file, just checking for
// "gz" is not sufficient as uncompressed files will be opened with
@@ -931,7 +937,7 @@ unsigned long FileFd::Size()
/* unfortunately zlib.h doesn't provide a gzsize(), so we have to do
* this ourselves; the original (uncompressed) file size is the last 32
* bits of the file */
- orig_pos = lseek(iFd, 0, SEEK_CUR);
+ off_t orig_pos = lseek(iFd, 0, SEEK_CUR);
if (lseek(iFd, -4, SEEK_END) < 0)
return _error->Errno("lseek","Unable to seek to end of gzipped file");
if (read(iFd, &size, 4) != 4)
diff --git a/apt-pkg/contrib/fileutl.h b/apt-pkg/contrib/fileutl.h
index 419506273..1380f06b4 100644
--- a/apt-pkg/contrib/fileutl.h
+++ b/apt-pkg/contrib/fileutl.h
@@ -63,6 +63,7 @@ class FileFd
bool Truncate(unsigned long To);
unsigned long Tell();
unsigned long Size();
+ unsigned long FileSize();
bool Open(string FileName,OpenMode Mode,unsigned long Perms = 0666);
bool OpenDescriptor(int Fd, OpenMode Mode, bool AutoClose=false);
bool Close();
diff --git a/debian/changelog b/debian/changelog
index 5ff165cfe..eb716b904 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,15 @@
+apt (0.8.8) UNRELEASED; urgency=low
+
+ [ David Kalnischkies ]
+ * apt-pkg/contrib/fileutl.cc:
+ - Add a FileFd::FileSize() method to get the size of the underlying
+ file and not the size of the content in the file as FileFd::Size()
+ does - the sizes can differ since the direct gzip integration
+ * methods/{gzip,bzip2}.cc:
+ - use FileSize() to determine if the file is invalid (Closes: #600852)
+
+ -- David Kalnischkies <kalnischkies@gmail.com> Thu, 21 Oct 2010 16:53:10 +0200
+
apt (0.8.7) unstable; urgency=low
[ Manpages translations ]
diff --git a/methods/bzip2.cc b/methods/bzip2.cc
index c668141a2..ccc3669a2 100644
--- a/methods/bzip2.cc
+++ b/methods/bzip2.cc
@@ -57,7 +57,7 @@ bool Bzip2Method::Fetch(FetchItem *Itm)
FileFd From(Path,FileFd::ReadOnly);
// FIXME add an error message saying that empty files can't be valid archives
- if(From.Size() == 0)
+ if(From.FileSize() == 0)
return false;
int GzOut[2];
diff --git a/methods/gzip.cc b/methods/gzip.cc
index 22cae9424..f1c76066e 100644
--- a/methods/gzip.cc
+++ b/methods/gzip.cc
@@ -49,7 +49,7 @@ bool GzipMethod::Fetch(FetchItem *Itm)
FileFd From(Path,FileFd::ReadOnlyGzip);
// FIXME add an error message saying that empty files can't be valid archives
- if(From.Size() == 0)
+ if(From.FileSize() == 0)
return false;
FileFd To(Itm->DestFile,FileFd::WriteAtomic);
diff --git a/test/integration/test-bug-595691-empty-and-broken-archive-files b/test/integration/test-bug-595691-empty-and-broken-archive-files
index 2f127221a..11a5025d2 100755
--- a/test/integration/test-bug-595691-empty-and-broken-archive-files
+++ b/test/integration/test-bug-595691-empty-and-broken-archive-files
@@ -10,6 +10,7 @@ buildaptarchive
setupflataptarchive
testaptgetupdate() {
+ rm -rf rootdir/var/lib/apt rootdir/var/cache/apt
aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
sed -i -e '/^Fetched / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
GIVEN="$1"
@@ -23,69 +24,125 @@ testaptgetupdate() {
rm testaptgetupdate.diff
}
-touch aptarchive/en.bz2
+createemptyarchive() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages
+ echo -n "" | $COMPRESSOR > aptarchive/${1}.$COMPRESS
+ aptftparchive release aptarchive/ > aptarchive/Release
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-testaptgetupdate "Ign file: Release.gpg
-Ign file:$(readlink -f aptarchive)/ Translation-en
-Get:1 file: Release []
-Reading package lists..." "empty file en.bz2 over file"
+createemptyfile() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages aptarchive/${1}.$COMPRESS
+ aptftparchive release aptarchive/ > aptarchive/Release
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
+setupcompressor() {
+ COMPRESSOR="$1"
+ case $COMPRESSOR in
+ gzip) COMPRESS="gz";;
+ bzip2) COMPRESS="bz2";;
+ lzma) COMPRESS="lzma";;
+ esac
+ echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
+Dir::Bin::gzip \"/does/not/exist\";
+Dir::Bin::bzip2 \"/does/not/exist\";
+Dir::Bin::lzma \"/does/not/exist\";" > rootdir/etc/apt/apt.conf.d/00compressor
+ if [ -e "/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ else
+ msgtest "Test for availability of compressor" "${COMPRESSOR}"
+ msgfail
+ exit 1
+ fi
+}
-testaptgetupdate "Ign file: Release.gpg
-Get:1 file: Release []
-Reading package lists..." "empty archive en.bz2 over file"
+testoverfile() {
+ setupcompressor "$1"
-rm aptarchive/en.bz2
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 file: Release.gpg []
+Get:2 file: Release []
+Ign file:$(readlink -f aptarchive)/ Translation-en
+Reading package lists..." "empty file en.$COMPRESS over file"
+
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 file: Release.gpg []
+Get:2 file: Release []
+Reading package lists..." "empty archive en.$COMPRESS over file"
+
+ createemptyarchive 'Packages'
+ # FIXME: Why omits the file transport the Packages Get line?
+ #Get:3 file: Packages []
+ testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
+Get:1 file: Release.gpg []
+Get:2 file: Release []
+Reading package lists..." "empty archive Packages.$COMPRESS over file"
+
+ createemptyfile 'Packages'
+ testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
+Get:1 file: Release.gpg []
+Get:2 file: Release []
+Err file: Packages
+ Undetermined Error
+W: Failed to fetch file:$(readlink -f aptarchive/Packages.$COMPRESS) Undetermined Error
-# do the same again with http instead of file
-changetowebserver
+E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over file"
+}
-touch aptarchive/en.bz2
+testoverhttp() {
+ setupcompressor "$1"
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en
-Get:2 http://localhost Release []
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
+Get:2 http://localhost/ Translation-en
+Get:3 http://localhost Release []
+Ign http://localhost/ Translation-en
+Get:4 http://localhost Packages []
+Reading package lists..." "empty file en.$COMPRESS over http"
+
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
+Get:2 http://localhost/ Translation-en []
+Get:3 http://localhost Release []
+Get:4 http://localhost Packages []
+Reading package lists..." "empty archive en.$COMPRESS over http"
+
+ createemptyarchive 'Packages'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
Ign http://localhost/ Translation-en
-Get:3 http://localhost Packages []
-Reading package lists..." "empty file en.bz2 over http"
-
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en []
Get:2 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
Get:3 http://localhost Packages []
-Reading package lists..." "empty archive en.bz2 over http"
-
-rm aptarchive/en.bz2
-
-rm aptarchive/Packages
-touch aptarchive/Packages
-buildaptarchivefromfiles
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages []
-Reading package lists..." "empty archive Packages over http"
-
-find aptarchive/ -name 'Packages*' -type f -delete
-touch aptarchive/Packages.bz2
-aptftparchive release aptarchive/ > aptarchive/Release
+Reading package lists..." "empty archive Packages.$COMPRESS over http"
-#FIXME: we should response with a good error message instead
-testaptgetupdate "Ign http://localhost Release.gpg
+ createemptyfile 'Packages'
+ #FIXME: we should response with a good error message instead
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages
+Get:2 http://localhost Release []
+Get:3 http://localhost Packages
Err http://localhost Packages
Undetermined Error
-W: Failed to fetch http://localhost:8080/Packages.bz2 Undetermined Error
+W: Failed to fetch http://localhost:8080/Packages.$COMPRESS Undetermined Error
+
+E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
+}
+
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverfile $COMPRESSOR; done
+
+# do the same again with http instead of file
+changetowebserver
-E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages over http"
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverhttp $COMPRESSOR; done